﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Sets
{
    public partial class MainForm : Form
    {
        //Rectangle set1;
        //Rectangle set2;

        private IList<Rectangle> sets;
        private IList<Color> colours;

        private bool lastComplete;

        public MainForm()
        {
            InitializeComponent();

            //set1 = new Rectangle(20, 20, 120, 50);
            //set2 = new Rectangle(40, 60, 80, 80);

            colourComboBox.Items.AddRange(Enum.GetValues(typeof(KnownColor)).Cast<object>().ToArray());
            colourComboBox.SelectedIndex = 0;

            sets = new List<Rectangle>();
            colours = new List<Color>();

            lastComplete = true;

            Paint += (sender, e) =>
                {
                    for (int i = 0; i < sets.Count; i++)
                    {
                        if ((i == (sets.Count - 1)) && !lastComplete)
                        {
                            e.Graphics.DrawRectangle(new Pen(colours[i]), sets[i]);
                        }
                        else
                        {
                            e.Graphics.FillRectangle(new SolidBrush(colours[i]), sets[i]);
                        }
                    }

                    //e.Graphics.FillRectangle(Brushes.Navy, set1);
                    //e.Graphics.FillRectangle(Brushes.IndianRed, set2);
                    //
                    //Point leftTopmostCorner = new Point
                    //    (
                    //        Math.Max(set1.X, set2.X),
                    //        Math.Max(set1.Y, set2.Y)
                    //    );
                    //
                    //Size size = new Size
                    //    (
                    //        (Math.Min(set1.Right, set2.Right) - leftTopmostCorner.X),
                    //        (Math.Min(set1.Bottom, set2.Bottom) - leftTopmostCorner.Y)
                    //    );
                    //
                    //e.Graphics.FillRectangle(Brushes.Goldenrod, new Rectangle(leftTopmostCorner, size));
                };

            MouseUp += (sender, e) =>
                {
                    if (!lastComplete)
                    {
                        lastComplete = true;

                        newToolStripMenuItem.Enabled = true;
                        MouseDown -= MyMouseDown;

                        Invalidate();
                    }
                };

            MouseMove += (sender, e) =>
                {
                    if (!lastComplete)
                    {
                        Rectangle last = sets.Last();
                        last.Width = (e.X - last.X);
                        last.Height = (e.Y - last.Y);
                        sets[sets.Count - 1] = last;

                        Invalidate();
                    }
                };
        }

        public void MyMouseDown(object sender, MouseEventArgs e)
        {
            if (lastComplete)
            {
                lastComplete = false;

                sets.Add(new Rectangle(e.X, e.Y, 0, 0));
            }
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            colours.Add(Color.FromName(colourComboBox.Text));

            newToolStripMenuItem.Enabled = false;
            MouseDown += MyMouseDown;
        }

        private void clearToolStripMenuItem_Click(object sender, EventArgs e)
        {
            sets = new List<Rectangle>();
            colours = new List<Color>();

            lastComplete = true;
        }

        private void quitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
    }
}
